//
// Created by philipp on 30.11.17.
//

#ifndef PROTOCOL_UTILS_H
#define PROTOCOL_UTILS_H

#include <iterator>

using boost::asio::ip::tcp;

namespace protocol
{
namespace utils
{

/**
 * Sets the iterator to the next element.
 * If the iterator is at container.end() it moves to back to container.begin()
 * @tparam ForwardIterator
 * @tparam Container
 * @param iter
 * @param container
 */
template<typename ForwardIterator, typename Container>
void cycle(ForwardIterator & iter, Container & container)
{
    if (std::next(iter) == container.end())
        iter = container.begin();
    else
        iter++;
}

}
}

#endif //PROTOCOL_UTILS_H