#include <iostream>
#include "../include/Protocol.h"
#include "../include/LeaderVehicle.h"
#include "../include/FollowerVehicle.h"

#if defined(PROTOCOL_TEST)

#include "ProtocolTest.h"

int main(int argc, char ** argv)
{
    std::cout << "testStop\n\n";
    protocol::test::testStop();

    return 0;
}

#else

int main(int argc, char ** argv)
{
    networking::Networking net1;
    networking::Networking net2;
    networking::Networking net3;

    auto leader = protocol::LeaderVehicle::create(net1, 1);
    protocol::FollowerVehicle follower1(net2, 2);
    protocol::FollowerVehicle follower2(net3, 3);

    leader->createPlatoon();
    follower1.createPlatoon();
    follower2.createPlatoon();

    while(!leader->isIdle() || !follower1.isIdle() || !follower2.isIdle())
    {
        leader->run();
        follower1.run();
        follower2.run();

        if (leader->isPlatoonRunning() && leader->getNumFollowers() == 2)
        {
            // just for printing
            leader->run();
            follower1.run();
            follower2.run();

            leader->leavePlatoon();
            follower1.leavePlatoon();
            follower2.leavePlatoon();
        }
    }

    return 0;
}

#endif